# Generated by Django 4.2.9 on 2024-01-11 20:43

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('cursus', '0001_initial'),
        ('core', '0052_site_related_name'),
        ('chronos', '0016_lessonevent'),
        ('kolego', '0003_refactor_absence'),
        ('alsijil', '0020_add_documentation_and_participation'),
    ]

    operations = [
        migrations.CreateModel(
            name='NewPersonalNote',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('managed_by_app_label', models.CharField(blank=True, editable=False, max_length=255, verbose_name='App label of app responsible for managing this instance')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('note', models.TextField(blank=True, verbose_name='Note')),
            ],
            options={
                'verbose_name': 'Personal Note',
                'verbose_name_plural': 'Personal Notes',
            },
        ),
        migrations.CreateModel(
            name='ParticipationStatus',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('managed_by_app_label', models.CharField(blank=True, editable=False, max_length=255, verbose_name='App label of app responsible for managing this instance')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('absent', models.BooleanField(verbose_name='Absent')),
                ('absence_reason', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='kolego.absencereason', verbose_name='Absence Reason')),
                ('base_absence', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='absences', to='kolego.absence', verbose_name='Base Absence')),
            ],
            options={
                'verbose_name': 'Participation Status',
                'verbose_name_plural': 'Participation Status',
                'ordering': ['documentation', 'person__last_name', 'person__first_name'],
            },
        ),
        migrations.AlterField(
            model_name='documentation',
            name='course',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='documentations', to='cursus.course', verbose_name='Course'),
        ),
        migrations.AlterField(
            model_name='documentation',
            name='group_note',
            field=models.CharField(blank=True, max_length=255, verbose_name='Group Note'),
        ),
        migrations.AlterField(
            model_name='documentation',
            name='lesson_event',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='documentation', to='chronos.lessonevent', verbose_name='Lesson Event'),
        ),
        migrations.AlterField(
            model_name='documentation',
            name='subject',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='+', to='cursus.subject', verbose_name='Subject'),
        ),
        migrations.AlterField(
            model_name='documentation',
            name='topic',
            field=models.CharField(blank=True, max_length=255, verbose_name='Lesson Topic'),
        ),
        migrations.DeleteModel(
            name='Participation',
        ),
        migrations.AddField(
            model_name='participationstatus',
            name='documentation',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='participations', to='alsijil.documentation', verbose_name='Documentation'),
        ),
        migrations.AddField(
            model_name='participationstatus',
            name='groups_of_person',
            field=models.ManyToManyField(related_name='+', to='core.group', verbose_name='Groups of Person'),
        ),
        migrations.AddField(
            model_name='participationstatus',
            name='person',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='participations', to='core.person', verbose_name='Person'),
        ),
        migrations.AddField(
            model_name='newpersonalnote',
            name='documentation',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='personal_notes', to='alsijil.documentation', verbose_name='Documentation'),
        ),
        migrations.AddField(
            model_name='newpersonalnote',
            name='extra_mark',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='alsijil.extramark', verbose_name='Extra Mark'),
        ),
        migrations.AddField(
            model_name='newpersonalnote',
            name='person',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='new_personal_notes', to='core.person', verbose_name='Person'),
        ),
        migrations.AddConstraint(
            model_name='participationstatus',
            constraint=models.UniqueConstraint(fields=('documentation', 'person'), name='unique_participation_status_per_documentation'),
        ),
        migrations.AddConstraint(
            model_name='newpersonalnote',
            constraint=models.CheckConstraint(check=models.Q(models.Q(('note', ''), _negated=True), ('extra_mark__isnull', False), _connector='OR'), name='unique_absence_per_documentation'),
        ),
    ]
